<!DOCTYPE html>
<html lang='en'>
<head>
<title>AGH-engineering-thesis - Code related to my engineering thesis at AGH University of Science and Technology in Kraków, Poland</title>
<meta name='generator' content='cgit v1.2.3'/>
<meta name='robots' content='noindex, nofollow'/>
<link rel='stylesheet' type='text/css' href='/cgit-static/cgit.css'/>
<link rel='stylesheet' type='text/css' href='/cgit-static/better-cgit-markdown-heading-color.css'/>
<link rel='shortcut icon' href='/cgit-static/favicon.ico'/>
<link rel='alternate' title='Atom feed' href='https://git.koszko.org/AGH-engineering-thesis/atom/models/vga_display.v?h=master' type='application/atom+xml'/>
</head>
<body>
<div id='cgit'><table id='header'>
<tr>
<td class='logo' rowspan='2'><a href='/'><img src='https://git.koszko.org/cgit-static/cgit.png' alt='cgit logo'/></a></td>
<td class='main'><a href='/'>index</a> : <a href='/AGH-engineering-thesis/'>AGH-engineering-thesis</a></td><td class='form'><form method='get'>
<input type='hidden' name='id' value='50066f519e9c59544bf3ef440c32109644ebaa9a'/><select name='h' onchange='this.form.submit();'>
<option value='master' selected='selected'>master</option>
</select> <input type='submit' val</td></tr></table>
<table class='tabs'><tr><td>
<a class='active' href='/guix/about/'>about</a><a href='/guix/'>summary</a><a href='/guix/refs/?id=1efed60faab3eb905e271471e3d049e</td></tr></table>
<table class='tabs'><tr><td>
<a href='/AGH-engineering-thesis/about/'>about</a><a href='/AGH-engineering-thesis/'>summary</a><a href='/AGH-engineering-thesis/refs/?id=50066f519e9c59544bf3ef440c32109644ebaa9a'>refs</a><a href='/AGH-engineering-thesis/log/models/vga_display.v'>log</a><a href='/AGH-engineering-thesis/tree/models/vga_display.v?id=50066f519e9c59544bf3ef440c32109644ebaa9a'>tree</a><a href='/AGH-engineering-thesis/commit/models/vga_display.v?id=50066f519e9c59544bf3ef440c32109644ebaa9a'>commit</a><a class='active' href='/AGH-engineering-thesis/diff/models/vga_display.v?id=50066f519e9c59544bf3ef440c32109644ebaa9a'>diff</a></td><td class='form'><form class='right' method='get' action='/AGH-engineering-thesis/log/models/vga_display.v'>
<input type='h<pre>
Make sure the build system honors C_INCLUDE_PATH and LIBRARY_PATH when
looking for headers and libraries.

--- a/setup.py	2015-10-07 23:32:58.891329173 +0200
+++ b/setup.py	2015-10-07 23:46:29.653349924 +0200
@@ -676,15 +676,15 @@
         # if a file is found in one of those directories, it can
         # be assumed that no additional -I,-L directives are needed.
         if not CROSS_COMPILING:
-            self.lib_dirs = self.compiler.library_dirs + system_lib_dirs
-            self.inc_dirs = self.compiler.include_dirs + system_include_dirs
+            self.lib_dirs = os.getenv(&apos;LIBRARY_PATH&apos;, &apos;&apos;).split(os.pathsep)
+            self.inc_dirs = os.getenv(&apos;C_INCLUDE_PATH&apos;, &apos;&apos;).split(os.pathsep)
         else:
             # Add the sysroot paths. &apos;sysroot&apos; is a compiler option used to
             # set the logical path of the standard system headers and
             # libraries.
-            self.lib_dirs = (self.compiler.library_dirs +
+            self.lib_dirs = (os.getenv(&apos;CROSS_LIBRARY_PATH&apos;, &apos;&apos;).split(os.pathsep) +
                              sysroot_paths((&apos;LDFLAGS&apos;, &apos;CC&apos;), system_lib_dirs))
-            self.inc_dirs = (self.compiler.include_dirs +
+            self.inc_dirs = (os.getenv(&apos;CROSS_C_INCLUDE_PATH&apos;, &apos;&apos;).split(os.pathsep) +
                              sysroot_paths((&apos;CPPFLAGS&apos;, &apos;CFLAGS&apos;, &apos;CC&apos;),
                                            system_include_dirs))
 
</pre>
</div></div> <!-- class=content -->
                         <div class=footer>generated by
                             <a href="https://git.zx2c4.com/cgit/about/">
                                 cgit
                             </a>
                         </div>
                        </div> <!-- id=cgit -->
</body>
</html>
ion value='1'>ssdiff</option><option value='2'>stat only</option></select></td></tr><tr><td/><td class='ctrl'><noscript><input type='submit' value='reload'/></noscript></td></tr></table></form></div><div class='diffstat-header'><a href='/AGH-engineering-thesis/diff/?id=50066f519e9c59544bf3ef440c32109644ebaa9a'>Diffstat</a> (limited to 'models/vga_display.v')</div><table summary='diffstat' class='diffstat'></table><div class='diffstat-summary'>0 files changed, 0 insertions, 0 deletions</div><table summary='diff' class='diff'><tr><td></td></tr></table></div> <!-- class=content -->
                         <div class=footer>generated by
                             <a href="https://git.zx2c4.com/cgit/about/">
                                 cgit
                             </a>
                         </div>
                        </div> <!-- id=cgit -->
</body>
</html>