<!DOCTYPE html>
<html lang='en'>
<head>
<title>gnu: Add rust-bitfield-0.13. - guix - Wojtek's customized Guix</title>
<meta name='generator' content='cgit v1.2.3'/>
<meta name='robots' content='noindex, nofollow'/>
<link rel='stylesheet' type='text/css' href='/cgit-static/cgit.css'/>
<link rel='stylesheet' type='text/css' href='/cgit-static/better-cgit-markdown-heading-color.css'/>
<link rel='shortcut icon' href='/cgit-static/favicon.ico'/>
<link rel='alternate' title='Atom feed' href='https://git.koszko.org/guix/atom/gnu/packages?h=koszko' type='application/atom+xml'/>
</head>
<body>
<div id='cgit'><table id='header'>
<tr>
<td class='logo' rowspan='2'><a href='/'><img src='https://git.koszko.org/cgit-static/cgit.png' alt='cgit logo'/></a></td>
<td class='main'><a href='/'>index</a> : <a href='/guix/'>guix</a></td><td class='form'><form method='get'>
<input type='hidden' name='id' value='6f9d5dac0b8fdbcbd9391101a413a2f3b5e8090f'/><select name='h' onchange='this.form.submit();'>
<option value='koszko' selected='selected'>koszko</option>
<option value='koszko-scripts'>koszko-scripts</option>
</select> <input type='submit' value='switch'/></form></td></tr>
<tr><td class='sub'>Wojtek's customized Guix</td><td class='sub right'></td></tr></table>
<table class='tabs'><tr><td>
<a href='/guix/about/'>about</a><a href='/guix/'>summary</a><a href='/guix/refs/?id=6f9d5dac0b8fdbcbd9391101a413a2f3b5e8090f'>refs</a><a href='/guix/log/gnu/packages'>log</a><a href='/guix/tree/gnu/packages?id=6f9d5dac0b8fdbcbd9391101a413a2f3b5e8090f'>tree</a><a class='active' href='/guix/commit/gnu/packages?id=6f9d5dac0b8fdbcbd9391101a413a2f3b5e8090f'>commit</a><a href='/guix/diff/gnu/packages?id=6f9d5dac0b8fdbcbd9391101a413a2f3b5e8090f'>diff</a></td><td class='form'><form class='right' method='get' action='/guix/log/gnu/packages'>
<input type='hidden' name='id' value='6f9d5dac0b8fdbcbd9391101a413a2f3b5e8090f'/><select name='qt'>
<option value='grep'>log msg</option>
<option value='author'>author</option>
<option value='committer'>committer</option>
<option value='range'>range</option>
</select>
<input class='txt' type='search' size='10' name='q' value=''/>
<input type='submit' value='search'/>
</form<pre>
Fix build against xorg-server &gt;= 1.20.

Patch taken from upstream:
https://cgit.freedesktop.org/xorg/driver/xf86-video-savage/commit/?id=0ece556daa8a88771b669d8104396abd9166d2d0

diff --git a/src/savage_driver.c b/src/savage_driver.c
index 58a294d..3cda923 100644
--- a/src/savage_driver.c
+++ b/src/savage_driver.c
@@ -2034,8 +2034,6 @@ static Bool SavagePreInit(ScrnInfoPtr pScrn, int flags)
     xf86DrvMsg(pScrn-&gt;scrnIndex, X_PROBED, &quot;Detected current MCLK value of %1.3f MHz\n&quot;,
 	       mclk / 1000.0);
 
-    pScrn-&gt;maxHValue = 2048 &lt;&lt; 3;	/* 11 bits of h_total 8-pixel units */
-    pScrn-&gt;maxVValue = 2048;		/* 11 bits of v_total */
     pScrn-&gt;virtualX = pScrn-&gt;display-&gt;virtualX;
     pScrn-&gt;virtualY = pScrn-&gt;display-&gt;virtualY;
 
@@ -3637,6 +3635,14 @@ static ModeStatus SavageValidMode(SCRN_ARG_TYPE arg, DisplayModePtr pMode,
        (pMode-&gt;VDisplay &gt; psav-&gt;PanelY)))
 	    return MODE_PANEL;
 
+    /* 11 bits of h_total 8-pixel units */
+    if (pMode-&gt;HTotal &gt; (2048 &lt;&lt; 3))
+	return MODE_BAD_HVALUE;
+
+    /* 11 bits of v_total */
+    if (pMode-&gt;VTotal &gt; 2048)
+	return MODE_BAD_VVALUE;
+
     if (psav-&gt;UseBIOS) {
 	refresh = SavageGetRefresh(pMode);
         return (SavageMatchBiosMode(pScrn,pMode-&gt;HDisplay,
</pre>
</div></div> <!-- class=content -->
                         <div class=footer>generated by
                             <a href="https://git.zx2c4.com/cgit/about/">
                                 cgit
                             </a>
                         </div>
                        </div> <!-- id=cgit -->
</body>
</html>
/form></div><table summary='commit info' class='commit-info'>
<tr><th>author</th><td>Nicolas Goaziou &lt;mail@nicolasgoaziou.fr&gt;</td><td class='right'>2021-12-27 18:50:45 +0100</td></tr>
<tr><th>committer</th><td>Leo Famulari &lt;leo@famulari.name&gt;</td><td class='right'>2021-12-28 14:10:23 -0500</td></tr>
<tr><th>commit</th><td colspan='2' class='oid'><a href='/guix/commit/gnu/packages?id=6f9d5dac0b8fdbcbd9391101a413a2f3b5e8090f'>6f9d5dac0b8fdbcbd9391101a413a2f3b5e8090f</a> (<a href='/guix/patch/gnu/packages?id=6f9d5dac0b8fdbcbd9391101a413a2f3b5e8090f'>patch</a>)</td></tr>
<tr><th>tree</th><td colspan='2' class='oid'><a href='/guix/tree/?id=6f9d5dac0b8fdbcbd9391101a413a2f3b5e8090f'>a8609ca90f664533b4245de5800943592eff2c8d</a> /<a href='/guix/tree/gnu/packages?id=6f9d5dac0b8fdbcbd9391101a413a2f3b5e8090f'>gnu/packages</a></td></tr>
<tr><th>parent</th><td colspan='2' class='oid'><a href='/guix/commit/gnu/packages?id=a2e0731375ddd532bf39871f001cf1e92b7f48a5'>a2e0731375ddd532bf39871f001cf1e92b7f48a5</a> (<a href='/guix/diff/gnu/packages?id=6f9d5dac0b8fdbcbd9391101a413a2f3b5e8090f&amp;id2=a2e0731375ddd532bf39871f001cf1e92b7f48a5'>diff</a>)</td></tr><tr><th>download</th><td colspan='2' class='oid'><a href='/guix/snapshot/guix-6f9d5dac0b8fdbcbd9391101a413a2f3b5e8090f.tar.gz'>guix-6f9d5dac0b8fdbcbd9391101a413a2f3b5e8090f.tar.gz</a><br/><a href='/guix/snapshot/guix-6f9d5dac0b8fdbcbd9391101a413a2f3b5e8090f.zip'>guix-6f9d5dac0b8fdbcbd9391101a413a2f3b5e8090f.zip</a><br/></td></tr></table>
<div class='commit-subject'>gnu: Add rust-bitfield-0.13.</div><div class='commit-msg'>* gnu/packages/crates-io.scm (rust-bitfield-0.13): New variable.
</div><div class='diffstat-header'><a href='/guix/diff/?id=6f9d5dac0b8fdbcbd9391101a413a2f3b5e8090f'>Diffstat</a> (limited to 'gnu/packages')</div><table summary='diffstat' class='diffstat'>